// ___SETA43  _____
// http://seta43.blogspot.com/
// Mando Infrarojo ___IRcopyV4all _____
//-Led OUT infrarojo PIN 3  arduino UNO
//-Led IN infrarojo PIN 2
// solo 10  teclas con memorias

#include <EEPROM.h>


#define IN_IR   2
#define OUT_IR   3
#define LED_TEST   13


unsigned int dato[100];


void setup()
{
  Serial.begin(9600);
  pinMode(LED_TEST, OUTPUT);   pinMode(OUT_IR, OUTPUT);
  pinMode(IN_IR, INPUT);

  //____TECLADO
  pinMode(4, OUTPUT); pinMode(5, OUTPUT); pinMode(6, OUTPUT); pinMode(7, OUTPUT);
  pinMode(8, INPUT); pinMode(9, INPUT); pinMode(10, INPUT); pinMode(11, INPUT);
  //___________________________________________________________________________
  
  frecuSET(199);  // 40KHz
  frecuOFF();
  Serial.println("Empieza IRcopyV4all SETA");
}

void loop()
{
 int pulsador;
 int z;
  pulsador = getKey();

  if (pulsador != 0)
  {
    Serial.print("TECLA="); Serial.println(pulsador);
    switch (pulsador)
    {
      case 16:
          Serial.println("Selecciona tecla");
          for (z = 0; z < 50; z++)
          {
            pulsador = getKey();
            if (pulsador != 0)  break;
            digitalWrite(LED_TEST, z & 1);
            delay(50);
          }
          Serial.println(pulsador);
          if (pulsador > 0  && pulsador<11)
          {
            Serial.print("Grabando tecla "); Serial.println(pulsador);
            digitalWrite(LED_TEST, 1);
            recKey(pulsador);
          }
          digitalWrite(LED_TEST, 0);
        break;
        
      default:
        if(pulsador>0 && pulsador<11)
          {
            Serial.print("Send tecla "); Serial.println(pulsador);
            sendKey(pulsador);
          }

      break;
    }

  }
salto:
  delay(1);

}

//_______FRECU______

void frecuSET(unsigned char f)
{
  //___________Contador 2___________ PIN3_________________

  // Clear Timer on Compare Match (CTC) Mode
  bitWrite(TCCR2A, WGM20, 0);
  bitWrite(TCCR2A, WGM21, 1);
  bitWrite(TCCR2B, WGM22, 0);
  //  bitWrite(TCCR2B, WGM23, 0);

  // Toggle OC1A and OC1B on Compare Match.
  bitWrite(TCCR2A, COM2A0, 1);
  bitWrite(TCCR2A, COM2A1, 0);
  bitWrite(TCCR2A, COM2B0, 1);
  bitWrite(TCCR2A, COM2B1, 0);

  // No prescaling
  bitWrite(TCCR2B, CS20, 1);
  bitWrite(TCCR2B, CS21, 0);
  bitWrite(TCCR2B, CS22, 0);

  OCR2A = f;
  OCR2B = f;

}

void frecuON(void)
{
  bitWrite(TCCR2A, COM2A0, 1);
  bitWrite(TCCR2A, COM2B0, 1);
}

void frecuOFF(void)
{
  bitWrite(TCCR2A, COM2A0, 0);
  bitWrite(TCCR2A, COM2B0, 0);
}




//______________________________________________________________
void sendKey(unsigned int t)
{
  unsigned int  x;
  byte c;
  for (x = 1; x < 99; x++)dato[x]=0;
  t--;
  t=t*100;
  Serial.print("Direcc.");Serial.println(t);
  for (x = 1; x < 99; x++)
  {
    c=EEPROM.read(t+x);
    if(c>191) {dato[x]=(c-192)*128; goto salto1;}
    if(c>127) {dato[x]=(c-128)*16; goto salto1;} 
    if(c>63) {dato[x]=(c-64)*4; goto salto1;}
    dato[x]=c; 
salto1:
    if (x > 3 && 2 > dato[x]) { Serial.println("=========="); break;    }    
  }
  sendDato();
}



void recKey(unsigned int t)
{
 unsigned int  x;
 byte c;
  Serial.print("Grabando tecla "); Serial.println(t);
  t--;
  t=t*100; 
  Serial.print("Direcc.");Serial.println(t);
  getDato();
  for (x = 1; x < 99; x++)
  {
    if(dato[x]<64){    c=dato[x]; goto salto;}
    if(dato[x]<256){    c=dato[x]/4+64; goto salto;}
    if(dato[x]<1024){    c=dato[x]/16+128; goto salto;}
    if(dato[x]<8192){    c=dato[x]/128+192; goto salto;}
    c=255;    
salto:   
    EEPROM.write(t+x,c); 
    Serial.print(t+x);Serial.print("DATO"); Serial.print(x); Serial.print("="); Serial.println(c);
    if (x > 3 && 2 > c)  { Serial.println("=====***=====");  break;  }  
  }
  

}

void sendDato(void)
{
  bool inicio;
  unsigned int  x;
  unsigned int retraso;

  inicio = 1;

  for (x = 1; x < 99; x++)
  {
    if (inicio == 1)
      frecuON();
    else
      frecuOFF();
    digitalWrite(LED_TEST, inicio);
    
    retraso = dato[x];
    if (retraso == 0) break;
    
    while (retraso > 1)
    {
      delayMicroseconds(20);
      delayMicroseconds(6); //para crear el mismo retraso.
      retraso--;
    }
    if (inicio == 0)
      inicio = 1;
    else
      inicio = 0;
  }

  frecuOFF();
  digitalWrite(OUT_IR, 0);
  digitalWrite(LED_TEST, 0);
}


void getDato(void)
{
  bool inicio;
  unsigned int  x;
  unsigned int retraso;

  for (x = 0; x < 99; x++) dato[x] = 0;

  inicio = digitalRead(IN_IR );
  while (inicio == digitalRead(IN_IR ))
  {
    digitalWrite(LED_TEST, HIGH);
  }
  digitalWrite(LED_TEST, LOW);
  
  inicio = digitalRead(IN_IR );
  dato[0] = inicio;
  for (x = 1; x < 99; x++)
  {
    retraso = 0;
    while (retraso < 40000)
    {
      delayMicroseconds(20);
      if (inicio != digitalRead(IN_IR)) break;
      retraso++;
    }
    inicio = digitalRead(IN_IR );

   
      if (retraso > 39000)
      {
        Serial.print(retraso); Serial.println("FIN");
        dato[x] = retraso;
        break;
      }
    
    dato[x] = retraso;
  }



  for (x = 0; x < 9; x++)
  {
    digitalWrite(LED_TEST, x & 1);
    delay(20);
    digitalWrite(LED_TEST, x & 1);
    delay(20);
  }

}

//______TECLADO_____



int getKey(void)
{
  int z;
  z = 0;
  digitalWrite(7, HIGH);
  delay(1);
  if (1 == digitalRead(8)) {
    z = 1;
    while (1 == digitalRead(8)) delay(1);
  }
  if (1 == digitalRead(9)) {
    z = 2;
    while (1 == digitalRead(9)) delay(1);
  }
  if (1 == digitalRead(10)) {
    z = 3;
    while (1 == digitalRead(10)) delay(1);
  }
  if (1 == digitalRead(11)) {
    z = 4;
    while (1 == digitalRead(11)) delay(1);
  }
  digitalWrite(7, LOW);

  digitalWrite(6, HIGH);
  delay(1);
  if (1 == digitalRead(8)) {
    z = 5;
    while (1 == digitalRead(8)) delay(1);
  }
  if (1 == digitalRead(9)) {
    z = 6;
    while (1 == digitalRead(9)) delay(1);
  }
  if (1 == digitalRead(10)) {
    z = 7;
    while (1 == digitalRead(10)) delay(1);
  }
  if (1 == digitalRead(11)) {
    z = 8;
    while (1 == digitalRead(11)) delay(1);
  }
  digitalWrite(6, LOW);

  digitalWrite(5, HIGH);
  delay(1);
  if (1 == digitalRead(8)) {
    z = 9;
    while (1 == digitalRead(8)) delay(1);
  }
  if (1 == digitalRead(9)) {
    z = 10;
    while (1 == digitalRead(9)) delay(1);
  }
  if (1 == digitalRead(10)) {
    z = 11;
    while (1 == digitalRead(10)) delay(1);
  }
  if (1 == digitalRead(11)) {
    z = 12;
    while (1 == digitalRead(11)) delay(1);
  }
  digitalWrite(5, LOW);

  digitalWrite(4, HIGH);
  delay(1);
  if (1 == digitalRead(8)) {
    z = 13;
    while (1 == digitalRead(8)) delay(1);
  }
  if (1 == digitalRead(9)) {
    z = 14;
    while (1 == digitalRead(9)) delay(1);
  }
  if (1 == digitalRead(10)) {
    z = 15;
    while (1 == digitalRead(10)) delay(1);
  }
  if (1 == digitalRead(11)) {
    z = 16;
    while (1 == digitalRead(11)) delay(1);
  }
  digitalWrite(4, LOW);
  return (z);
}

